Add signal handling doc to hbal man page
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Use bash in order to be able to use pipefail
18 SHELL=/bin/bash
19
20 ACLOCAL_AMFLAGS = -I autotools
21 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 CHECK_MAN = $(top_srcdir)/autotools/check-man
25 CHECK_VERSION = $(top_srcdir)/autotools/check-version
26 CHECK_NEWS = $(top_srcdir)/autotools/check-news
27 DOCPP = $(top_srcdir)/autotools/docpp
28 REPLACE_VARS_SED = autotools/replace_vars.sed
29 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
30
31 # Note: these are automake-specific variables, and must be named after
32 # the directory + 'dir' suffix
33 clientdir = $(pkgpythondir)/client
34 hypervisordir = $(pkgpythondir)/hypervisor
35 httpdir = $(pkgpythondir)/http
36 masterddir = $(pkgpythondir)/masterd
37 confddir = $(pkgpythondir)/confd
38 rapidir = $(pkgpythondir)/rapi
39 serverdir = $(pkgpythondir)/server
40 watcherdir = $(pkgpythondir)/watcher
41 impexpddir = $(pkgpythondir)/impexpd
42 utilsdir = $(pkgpythondir)/utils
43 toolsdir = $(pkglibdir)/tools
44 iallocatorsdir = $(pkglibdir)/iallocators
45 pytoolsdir = $(pkgpythondir)/tools
46 docdir = $(datadir)/doc/$(PACKAGE)
47
48 # Delete output file if an error occurred while building it
49 .DELETE_ON_ERROR:
50
51 HTOOLS_DIRS = \
52         htools \
53         htools/Ganeti \
54         htools/Ganeti/HTools \
55         htools/Ganeti/HTools/Program
56
57 DIRS = \
58         autotools \
59         daemons \
60         devel \
61         doc \
62         doc/examples \
63         doc/examples/hooks \
64         doc/examples/gnt-debug \
65         $(HTOOLS_DIRS) \
66         lib \
67         lib/client \
68         lib/build \
69         lib/confd \
70         lib/http \
71         lib/hypervisor \
72         lib/impexpd \
73         lib/masterd \
74         lib/rapi \
75         lib/server \
76         lib/tools \
77         lib/utils \
78         lib/watcher \
79         man \
80         qa \
81         test \
82         test/data \
83         tools
84
85 BUILDTIME_DIR_AUTOCREATE = \
86         scripts \
87         $(APIDOC_DIR) \
88         $(APIDOC_PY_DIR) \
89         $(APIDOC_HS_DIR) \
90         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
91         $(APIDOC_HS_DIR)/Ganeti/HTools/Program \
92         $(COVERAGE_DIR) \
93         $(COVERAGE_PY_DIR) \
94         $(COVERAGE_HS_DIR) \
95         .hpc
96
97 BUILDTIME_DIRS = \
98         $(BUILDTIME_DIR_AUTOCREATE) \
99         doc/html
100
101 DIRCHECK_EXCLUDE = \
102         $(BUILDTIME_DIRS) \
103         ganeti-[0-9]*.[0-9]*.[0-9]* \
104         doc/html/_*
105
106 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
107
108 # some helper vars
109 COVERAGE_DIR = doc/coverage
110 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
111 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
112 APIDOC_DIR = doc/api
113 APIDOC_PY_DIR = $(APIDOC_DIR)/py
114 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
115
116 MAINTAINERCLEANFILES = \
117         $(docpng) \
118         $(maninput) \
119         doc/install-quick.rst \
120         doc/news.rst \
121         doc/upgrade.rst \
122         vcs-version
123
124 maintainer-clean-local:
125         rm -rf $(BUILDTIME_DIRS)
126
127 CLEANFILES = \
128         $(addsuffix /*.py[co],$(DIRS)) \
129         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
130         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
131         $(all_dirfiles) \
132         $(PYTHON_BOOTSTRAP) \
133         epydoc.conf \
134         autotools/replace_vars.sed \
135         daemons/daemon-util \
136         daemons/ganeti-cleaner \
137         devel/upload \
138         doc/examples/bash_completion \
139         doc/examples/ganeti.initd \
140         doc/examples/ganeti-kvm-poweroff.initd \
141         doc/examples/ganeti.cron \
142         doc/examples/gnt-config-backup \
143         doc/examples/hooks/ipsec \
144         $(man_MANS) \
145         $(manhtml) \
146         tools/kvm-ifup \
147         stamp-srclinks \
148         $(nodist_pkgpython_PYTHON) \
149         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
150         .hpc/*.mix htools/*.tix \
151         doc/hs-lint.html
152
153 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
154 # it'll cause the target to rebuild every time.
155 BUILT_SOURCES = \
156         ganeti \
157         stamp-srclinks \
158         $(all_dirfiles) \
159         $(PYTHON_BOOTSTRAP) \
160         $(BUILT_PYTHON_SOURCES)
161
162 BUILT_PYTHON_SOURCES = \
163         lib/_autoconf.py \
164         lib/_vcsversion.py
165
166 nodist_pkgpython_PYTHON = \
167         $(BUILT_PYTHON_SOURCES)
168
169 noinst_PYTHON = \
170         lib/build/__init__.py \
171         lib/build/sphinx_ext.py
172
173 pkgpython_PYTHON = \
174         lib/__init__.py \
175         lib/asyncnotifier.py \
176         lib/backend.py \
177         lib/bdev.py \
178         lib/bootstrap.py \
179         lib/cli.py \
180         lib/cmdlib.py \
181         lib/compat.py \
182         lib/config.py \
183         lib/constants.py \
184         lib/daemon.py \
185         lib/errors.py \
186         lib/ht.py \
187         lib/jqueue.py \
188         lib/jstore.py \
189         lib/locking.py \
190         lib/luxi.py \
191         lib/mcpu.py \
192         lib/netutils.py \
193         lib/objects.py \
194         lib/opcodes.py \
195         lib/qlang.py \
196         lib/query.py \
197         lib/rpc.py \
198         lib/runtime.py \
199         lib/serializer.py \
200         lib/ssconf.py \
201         lib/ssh.py \
202         lib/storage.py \
203         lib/uidpool.py \
204         lib/workerpool.py
205
206 client_PYTHON = \
207         lib/client/__init__.py \
208         lib/client/gnt_backup.py \
209         lib/client/gnt_cluster.py \
210         lib/client/gnt_debug.py \
211         lib/client/gnt_group.py \
212         lib/client/gnt_instance.py \
213         lib/client/gnt_job.py \
214         lib/client/gnt_node.py \
215         lib/client/gnt_os.py
216
217 hypervisor_PYTHON = \
218         lib/hypervisor/__init__.py \
219         lib/hypervisor/hv_base.py \
220         lib/hypervisor/hv_chroot.py \
221         lib/hypervisor/hv_fake.py \
222         lib/hypervisor/hv_kvm.py \
223         lib/hypervisor/hv_lxc.py \
224         lib/hypervisor/hv_xen.py
225
226 rapi_PYTHON = \
227         lib/rapi/__init__.py \
228         lib/rapi/baserlib.py \
229         lib/rapi/client.py \
230         lib/rapi/client_utils.py \
231         lib/rapi/connector.py \
232         lib/rapi/rlib2.py
233
234 http_PYTHON = \
235         lib/http/__init__.py \
236         lib/http/auth.py \
237         lib/http/client.py \
238         lib/http/server.py
239
240 confd_PYTHON = \
241         lib/confd/__init__.py \
242         lib/confd/client.py \
243         lib/confd/querylib.py \
244         lib/confd/server.py
245
246 masterd_PYTHON = \
247         lib/masterd/__init__.py \
248         lib/masterd/instance.py
249
250 impexpd_PYTHON = \
251         lib/impexpd/__init__.py
252
253 watcher_PYTHON = \
254         lib/watcher/__init__.py \
255         lib/watcher/nodemaint.py \
256         lib/watcher/state.py
257
258 server_PYTHON = \
259         lib/server/__init__.py \
260         lib/server/confd.py \
261         lib/server/masterd.py \
262         lib/server/noded.py \
263         lib/server/rapi.py
264
265 pytools_PYTHON = \
266         lib/tools/__init__.py \
267         lib/tools/ensure_dirs.py
268
269 utils_PYTHON = \
270         lib/utils/__init__.py \
271         lib/utils/algo.py \
272         lib/utils/filelock.py \
273         lib/utils/hash.py \
274         lib/utils/io.py \
275         lib/utils/log.py \
276         lib/utils/mlock.py \
277         lib/utils/nodesetup.py \
278         lib/utils/process.py \
279         lib/utils/retry.py \
280         lib/utils/text.py \
281         lib/utils/wrapper.py \
282         lib/utils/x509.py
283
284 docrst = \
285         doc/admin.rst \
286         doc/design-2.0.rst \
287         doc/design-2.1.rst \
288         doc/design-2.2.rst \
289         doc/design-2.3.rst \
290         doc/design-htools-2.3.rst \
291         doc/design-2.4.rst \
292         doc/design-2.5.rst \
293         doc/design-draft.rst \
294         doc/design-oob.rst \
295         doc/design-cpu-pinning.rst \
296         doc/design-query2.rst \
297         doc/design-x509-ca.rst \
298         doc/design-http-server.rst \
299         doc/design-impexp2.rst \
300         doc/design-lu-generated-jobs.rst \
301         doc/design-multi-reloc.rst \
302         doc/design-network.rst \
303         doc/design-chained-jobs.rst \
304         doc/design-ovf-support.rst \
305         doc/cluster-merge.rst \
306         doc/design-shared-storage.rst \
307         doc/devnotes.rst \
308         doc/glossary.rst \
309         doc/hooks.rst \
310         doc/iallocator.rst \
311         doc/index.rst \
312         doc/install-quick.rst \
313         doc/install.rst \
314         doc/locking.rst \
315         doc/move-instance.rst \
316         doc/news.rst \
317         doc/rapi.rst \
318         doc/security.rst \
319         doc/upgrade.rst \
320         doc/walkthrough.rst
321
322 HS_PROGS = htools/htools
323 HS_BIN_ROLES = hbal hscan hspace
324
325 HS_ALL_PROGS = $(HS_PROGS) htools/test
326 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
327 # we don't add -Werror by default
328 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
329 # extra flags that can be overriden on the command line
330 HEXTRA =
331 # exclude options for coverage reports
332 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC \
333         --exclude Ganeti.Constants \
334         --exclude Ganeti.HTools.Version
335
336 HS_LIB_SRCS = \
337         htools/Ganeti/HTools/CLI.hs \
338         htools/Ganeti/HTools/Cluster.hs \
339         htools/Ganeti/HTools/Compat.hs \
340         htools/Ganeti/HTools/Container.hs \
341         htools/Ganeti/HTools/ExtLoader.hs \
342         htools/Ganeti/HTools/Group.hs \
343         htools/Ganeti/HTools/IAlloc.hs \
344         htools/Ganeti/HTools/Instance.hs \
345         htools/Ganeti/HTools/Loader.hs \
346         htools/Ganeti/HTools/Luxi.hs \
347         htools/Ganeti/HTools/Node.hs \
348         htools/Ganeti/HTools/PeerMap.hs \
349         htools/Ganeti/HTools/QC.hs \
350         htools/Ganeti/HTools/Rapi.hs \
351         htools/Ganeti/HTools/Simu.hs \
352         htools/Ganeti/HTools/Text.hs \
353         htools/Ganeti/HTools/Types.hs \
354         htools/Ganeti/HTools/Utils.hs \
355         htools/Ganeti/HTools/Program/Hail.hs \
356         htools/Ganeti/HTools/Program/Hbal.hs \
357         htools/Ganeti/HTools/Program/Hscan.hs \
358         htools/Ganeti/HTools/Program/Hspace.hs \
359         htools/Ganeti/Jobs.hs \
360         htools/Ganeti/Luxi.hs \
361         htools/Ganeti/OpCodes.hs
362
363 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
364 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
365
366 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
367
368 # Note: we use here an order-only prerequisite, as the contents of
369 # _autoconf.py are not actually influencing the html build output: it
370 # has to exist in order for the sphinx module to be loaded
371 # successfully, but we certainly don't want the docs to be rebuilt if
372 # it changes
373 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
374         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
375         | $(BUILT_PYTHON_SOURCES)
376         @test -n "$(SPHINX)" || \
377             { echo 'sphinx-build' not found during configure; exit 1; }
378         @mkdir_p@ $(dir $@)
379         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
380             -d . \
381             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
382             -D release="$(PACKAGE_VERSION)" \
383             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
384         rm -f doc/html/.buildinfo doc/html/objects.inv
385         touch $@
386
387 doc/html: doc/html/index.html
388
389 doc/install-quick.rst: INSTALL
390 doc/news.rst: NEWS
391 doc/upgrade.rst: UPGRADE
392
393 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
394         set -e; \
395         { echo '.. This file is automatically updated at build time from $<.'; \
396           echo '.. Do not edit.'; \
397           echo; \
398           cat $<; \
399         } > $@
400
401 docdot = \
402         doc/arch-2.0.dot \
403         doc/design-2.1-lock-acquire.dot \
404         doc/design-2.1-lock-release.dot
405
406 docpng = $(patsubst %.dot,%.png,$(docdot))
407
408 # Things to build but not to install (add it to EXTRA_DIST if it should be
409 # distributed)
410 noinst_DATA = \
411         devel/upload \
412         doc/html \
413         doc/examples/bash_completion \
414         doc/examples/ganeti.cron \
415         doc/examples/ganeti.initd \
416         doc/examples/ganeti-kvm-poweroff.initd \
417         doc/examples/gnt-config-backup \
418         doc/examples/hooks/ipsec \
419         $(manhtml)
420
421 gnt_scripts = \
422         scripts/gnt-backup \
423         scripts/gnt-cluster \
424         scripts/gnt-debug \
425         scripts/gnt-group \
426         scripts/gnt-instance \
427         scripts/gnt-job \
428         scripts/gnt-node \
429         scripts/gnt-os
430
431 PYTHON_BOOTSTRAP_SBIN = \
432         daemons/ganeti-confd \
433         daemons/ganeti-masterd \
434         daemons/ganeti-noded \
435         daemons/ganeti-watcher \
436         daemons/ganeti-rapi \
437         scripts/gnt-backup \
438         scripts/gnt-cluster \
439         scripts/gnt-debug \
440         scripts/gnt-group \
441         scripts/gnt-instance \
442         scripts/gnt-job \
443         scripts/gnt-node \
444         scripts/gnt-os
445
446 PYTHON_BOOTSTRAP = \
447         $(PYTHON_BOOTSTRAP_SBIN) \
448         tools/ensure-dirs
449
450 qa_scripts = \
451         qa/ganeti-qa.py \
452         qa/qa_cluster.py \
453         qa/qa_config.py \
454         qa/qa_daemon.py \
455         qa/qa_env.py \
456         qa/qa_error.py \
457         qa/qa_group.py \
458         qa/qa_instance.py \
459         qa/qa_node.py \
460         qa/qa_os.py \
461         qa/qa_rapi.py \
462         qa/qa_tags.py \
463         qa/qa_utils.py
464
465 bin_SCRIPTS =
466 if WANT_HTOOLS
467 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
468 install-exec-hook:
469         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
470 # FIXME: this is a hardcoded logic, instead of auto-resolving
471         $(LN_S) -f ../../../bin/htools \
472                    $(DESTDIR)$(iallocatorsdir)/hail
473         for role in $(HS_BIN_ROLES); do \
474                 $(LN_S) -f htools \
475                            $(DESTDIR)$(bindir)/$$role ; \
476         done
477 endif
478
479 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
480         @if [ -z "$(HTOOLS)" ]; then \
481           echo "Error: htools compilation disabled at configure time" 1>&2 ;\
482           exit 1; \
483         fi
484         @BINARY=$(@:htools/%=%); \
485         if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
486           echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
487           exit 1; \
488         fi
489         BINARY=$(@:htools/%=%); $(GHC) --make \
490           $(HFLAGS) $(HEXTRA) \
491           $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
492           -osuf $$BINARY.o -hisuf $$BINARY.hi $@
493
494 # for the htools/test binary, we need to enable profiling/coverage
495 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
496         -fno-warn-monomorphism-restriction -fno-warn-orphans \
497         -fno-warn-missing-methods -fno-warn-unused-imports
498
499 dist_sbin_SCRIPTS = \
500         tools/ganeti-listrunner
501
502 nodist_sbin_SCRIPTS = \
503         $(PYTHON_BOOTSTRAP_SBIN) \
504         daemons/ganeti-cleaner
505
506 dist_tools_PYTHON = \
507         tools/burnin \
508         tools/cfgshell \
509         tools/cfgupgrade \
510         tools/cfgupgrade12 \
511         tools/cluster-merge \
512         tools/lvmstrap \
513         tools/move-instance \
514         tools/setup-ssh \
515         tools/sanitize-config
516
517 dist_tools_SCRIPTS = \
518         $(dist_tools_PYTHON) \
519         tools/kvm-console-wrapper \
520         tools/xm-console-wrapper
521
522 pkglib_python_scripts = \
523         daemons/import-export \
524         tools/check-cert-expired
525
526 nodist_pkglib_python_scripts = \
527         tools/ensure-dirs
528
529 pkglib_SCRIPTS = \
530         daemons/daemon-util \
531         tools/kvm-ifup \
532         $(pkglib_python_scripts)
533
534 nodist_pkglib_SCRIPTS = \
535         $(nodist_pkglib_python_scripts)
536
537 EXTRA_DIST = \
538         NEWS \
539         UPGRADE \
540         epydoc.conf.in \
541         pylintrc \
542         autotools/build-bash-completion \
543         autotools/check-python-code \
544         autotools/check-man \
545         autotools/check-news \
546         autotools/check-tar \
547         autotools/check-version \
548         autotools/convert-constants \
549         autotools/docpp \
550         autotools/gen-coverage \
551         autotools/testrunner \
552         $(RUN_IN_TEMPDIR) \
553         daemons/daemon-util.in \
554         daemons/ganeti-cleaner.in \
555         $(pkglib_python_scripts) \
556         devel/upload.in \
557         tools/kvm-ifup.in \
558         $(docdot) \
559         $(docpng) \
560         $(docrst) \
561         doc/conf.py \
562         doc/html \
563         doc/examples/ganeti.initd.in \
564         doc/examples/ganeti-kvm-poweroff.initd.in \
565         doc/examples/ganeti.cron.in \
566         doc/examples/gnt-config-backup.in \
567         doc/examples/ganeti.default \
568         doc/examples/ganeti.default-debug \
569         doc/examples/hooks/ethers \
570         doc/examples/hooks/ipsec.in \
571         doc/examples/gnt-debug/README \
572         doc/examples/gnt-debug/delay0.json \
573         doc/examples/gnt-debug/delay50.json \
574         test/testutils.py \
575         test/mocks.py \
576         $(dist_TESTS) \
577         $(TEST_FILES) \
578         man/footer.rst \
579         $(manrst) \
580         $(maninput) \
581         qa/qa-sample.json \
582         $(qa_scripts) \
583         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
584         $(HS_PROG_SRCS)
585
586 man_MANS = \
587         man/ganeti.7 \
588         man/ganeti-cleaner.8 \
589         man/ganeti-confd.8 \
590         man/ganeti-listrunner.8 \
591         man/ganeti-masterd.8 \
592         man/ganeti-noded.8 \
593         man/ganeti-os-interface.7 \
594         man/ganeti-rapi.8 \
595         man/ganeti-watcher.8 \
596         man/gnt-backup.8 \
597         man/gnt-cluster.8 \
598         man/gnt-debug.8 \
599         man/gnt-group.8 \
600         man/gnt-instance.8 \
601         man/gnt-job.8 \
602         man/gnt-node.8 \
603         man/gnt-os.8 \
604         man/hail.1 \
605         man/hbal.1 \
606         man/hscan.1 \
607         man/hspace.1 \
608         man/htools.1
609
610 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
611 manhtml = $(patsubst %.rst,%.html,$(manrst))
612 mangen = $(patsubst %.rst,%.gen,$(manrst))
613 maninput = \
614         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
615         $(patsubst %.html,%.html.in,$(manhtml)) \
616         man/footer.man man/footer.html $(mangen)
617
618 TEST_FILES = \
619         test/data/bdev-drbd-8.0.txt \
620         test/data/bdev-drbd-8.3.txt \
621         test/data/bdev-drbd-disk.txt \
622         test/data/bdev-drbd-net-ip4.txt \
623         test/data/bdev-drbd-net-ip6.txt \
624         test/data/cert1.pem \
625         test/data/ip-addr-show-dummy0.txt \
626         test/data/ip-addr-show-lo-ipv4.txt \
627         test/data/ip-addr-show-lo-ipv6.txt \
628         test/data/ip-addr-show-lo-oneline-ipv4.txt \
629         test/data/ip-addr-show-lo-oneline-ipv6.txt \
630         test/data/ip-addr-show-lo-oneline.txt \
631         test/data/ip-addr-show-lo.txt \
632         test/data/proc_drbd8.txt \
633         test/data/proc_drbd80-emptyline.txt \
634         test/data/proc_drbd83.txt \
635         test/data/proc_drbd83_sync.txt \
636         test/data/proc_drbd83_sync_krnl2.6.39.txt \
637         test/data/sys_drbd_usermode_helper.txt \
638         test/import-export_unittest-helper
639
640 python_tests = \
641         test/ganeti.asyncnotifier_unittest.py \
642         test/ganeti.backend_unittest.py \
643         test/ganeti.bdev_unittest.py \
644         test/ganeti.cli_unittest.py \
645         test/ganeti.client.gnt_cluster_unittest.py \
646         test/ganeti.client.gnt_instance_unittest.py \
647         test/ganeti.daemon_unittest.py \
648         test/ganeti.cmdlib_unittest.py \
649         test/ganeti.compat_unittest.py \
650         test/ganeti.confd.client_unittest.py \
651         test/ganeti.config_unittest.py \
652         test/ganeti.constants_unittest.py \
653         test/ganeti.errors_unittest.py \
654         test/ganeti.hooks_unittest.py \
655         test/ganeti.ht_unittest.py \
656         test/ganeti.http_unittest.py \
657         test/ganeti.hypervisor_unittest.py \
658         test/ganeti.hypervisor.hv_chroot_unittest.py \
659         test/ganeti.hypervisor.hv_fake_unittest.py \
660         test/ganeti.hypervisor.hv_kvm_unittest.py \
661         test/ganeti.hypervisor.hv_lxc_unittest.py \
662         test/ganeti.hypervisor.hv_xen_unittest.py \
663         test/ganeti.impexpd_unittest.py \
664         test/ganeti.jqueue_unittest.py \
665         test/ganeti.locking_unittest.py \
666         test/ganeti.luxi_unittest.py \
667         test/ganeti.masterd.instance_unittest.py \
668         test/ganeti.mcpu_unittest.py \
669         test/ganeti.netutils_unittest.py \
670         test/ganeti.objects_unittest.py \
671         test/ganeti.opcodes_unittest.py \
672         test/ganeti.qlang_unittest.py \
673         test/ganeti.query_unittest.py \
674         test/ganeti.rapi.baserlib_unittest.py \
675         test/ganeti.rapi.client_unittest.py \
676         test/ganeti.rapi.resources_unittest.py \
677         test/ganeti.rapi.rlib2_unittest.py \
678         test/ganeti.rpc_unittest.py \
679         test/ganeti.runtime_unittest.py \
680         test/ganeti.serializer_unittest.py \
681         test/ganeti.ssh_unittest.py \
682         test/ganeti.tools.ensure_dirs_unittest.py \
683         test/ganeti.uidpool_unittest.py \
684         test/ganeti.utils.algo_unittest.py \
685         test/ganeti.utils.filelock_unittest.py \
686         test/ganeti.utils.hash_unittest.py \
687         test/ganeti.utils.io_unittest.py \
688         test/ganeti.utils.log_unittest.py \
689         test/ganeti.utils.mlock_unittest.py \
690         test/ganeti.utils.nodesetup_unittest.py \
691         test/ganeti.utils.process_unittest.py \
692         test/ganeti.utils.retry_unittest.py \
693         test/ganeti.utils.text_unittest.py \
694         test/ganeti.utils.wrapper_unittest.py \
695         test/ganeti.utils.x509_unittest.py \
696         test/ganeti.utils_unittest.py \
697         test/ganeti.workerpool_unittest.py \
698         test/cfgupgrade_unittest.py \
699         test/docs_unittest.py \
700         test/tempfile_fork_unittest.py
701
702 haskell_tests = htools/test
703
704 dist_TESTS = \
705         test/check-cert-expired_unittest.bash \
706         test/daemon-util_unittest.bash \
707         test/ganeti-cleaner_unittest.bash \
708         test/import-export_unittest.bash \
709         $(python_tests)
710
711 nodist_TESTS =
712 if WANT_HTOOLSTESTS
713 nodist_TESTS += $(haskell_tests)
714 endif
715
716 TESTS = $(dist_TESTS) $(nodist_TESTS)
717
718 # Environment for all tests
719 PLAIN_TESTS_ENVIRONMENT = \
720         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
721
722 # Environment for tests run by automake
723 TESTS_ENVIRONMENT = \
724         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
725
726 all_python_code = \
727         $(dist_sbin_SCRIPTS) \
728         $(dist_tools_PYTHON) \
729         $(pkglib_python_scripts) \
730         $(nodist_pkglib_python_scripts) \
731         $(python_tests) \
732         $(pkgpython_PYTHON) \
733         $(client_PYTHON) \
734         $(hypervisor_PYTHON) \
735         $(rapi_PYTHON) \
736         $(server_PYTHON) \
737         $(pytools_PYTHON) \
738         $(http_PYTHON) \
739         $(confd_PYTHON) \
740         $(masterd_PYTHON) \
741         $(impexpd_PYTHON) \
742         $(utils_PYTHON) \
743         $(watcher_PYTHON) \
744         $(noinst_PYTHON) \
745         $(qa_scripts)
746
747 srclink_files = \
748         man/footer.rst \
749         test/check-cert-expired_unittest.bash \
750         test/daemon-util_unittest.bash \
751         test/ganeti-cleaner_unittest.bash \
752         test/import-export_unittest.bash \
753         $(all_python_code) \
754         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
755
756 check_python_code = \
757         $(BUILD_BASH_COMPLETION) \
758         $(DOCPP) \
759         $(all_python_code)
760
761 lint_python_code = \
762         ganeti \
763         ganeti/http/server.py \
764         $(dist_sbin_SCRIPTS) \
765         $(dist_tools_PYTHON) \
766         $(pkglib_python_scripts) \
767         $(BUILD_BASH_COMPLETION) \
768         $(DOCPP) \
769         $(PYTHON_BOOTSTRAP)
770
771 pep8_python_code = \
772         ganeti \
773         ganeti/http/server.py \
774         $(dist_sbin_SCRIPTS) \
775         $(dist_tools_PYTHON) \
776         $(pkglib_python_scripts) \
777         $(BUILD_BASH_COMPLETION) \
778         $(DOCPP) \
779         $(PYTHON_BOOTSTRAP) \
780         qa
781
782 test/daemon-util_unittest.bash: daemons/daemon-util
783
784 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
785
786 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
787         sed -f $(REPLACE_VARS_SED) < $< > $@
788         chmod +x $@
789
790 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
791         sed -f $(REPLACE_VARS_SED) < $< > $@
792         chmod u+x $@
793
794 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
795         sed -f $(REPLACE_VARS_SED) < $< > $@
796         chmod +x $@
797
798 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
799         sed -f $(REPLACE_VARS_SED) < $< > $@
800
801 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
802         sed -f $(REPLACE_VARS_SED) < $< > $@
803
804 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
805         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
806         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
807
808 doc/%.png: doc/%.dot
809         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
810         $(DOT) -Tpng -o $@ $<
811
812 man/footer.man: man/footer.rst
813         @test -n "$(PANDOC)" || \
814           { echo 'pandoc' not found during configure; exit 1; }
815         $(PANDOC) -f rst -t man -o $@ $<
816
817 man/footer.html: man/footer.rst
818         @test -n "$(PANDOC)" || \
819           { echo 'pandoc' not found during configure; exit 1; }
820         $(PANDOC) -f rst -t html -o $@ $<
821
822 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
823         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
824
825 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
826         @test -n "$(PANDOC)" || \
827           { echo 'pandoc' not found during configure; exit 1; }
828         set -o pipefail ; \
829         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
830           sed -e 's/\\@/@/g' > $@
831         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
832
833 man/%.html.in: man/%.gen man/footer.html
834         @test -n "$(PANDOC)" || \
835           { echo 'pandoc' not found during configure; exit 1; }
836         set -o pipefail ; \
837         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
838           sed -e 's/\\@/@/g' > $@
839
840 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
841         sed -f $(REPLACE_VARS_SED) < $< > $@
842
843 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
844         sed -f $(REPLACE_VARS_SED) < $< > $@
845
846 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
847         sed -f $(REPLACE_VARS_SED) < $< > $@
848
849 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
850         sed -f $(REPLACE_VARS_SED) < $< > $@
851
852 epydoc.conf: epydoc.conf.in Makefile
853         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
854
855 vcs-version:
856         if test -d .git; then \
857           git describe > $@; \
858         elif test ! -f $@ ; then \
859           echo "Cannot auto-generate $@ file"; exit 1; \
860         fi
861
862 .PHONY: regen-vcs-version
863 regen-vcs-version:
864         set -e; \
865         cd $(srcdir); \
866         if test -d .git; then \
867           rm -f vcs-version; \
868           $(MAKE) vcs-version; \
869         fi
870
871 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
872         set -e; \
873         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
874         sed -e "s/%ver%/$$VCSVER/" < $< > $@
875
876 htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
877         lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS)
878         set -e; \
879         { cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
880
881 lib/_autoconf.py: Makefile | lib/.dir
882         set -e; \
883         { echo '# This file is automatically generated, do not edit!'; \
884           echo '#'; \
885           echo ''; \
886           echo '"""Build-time configuration for Ganeti.'; \
887           echo '';\
888           echo 'This file is autogenerated by the build process.'; \
889           echo 'For any changes you need to re-run ./configure (and'; \
890           echo 'not edit by hand).'; \
891           echo ''; \
892           echo '"""'; \
893           echo ''; \
894           echo '# pylint: disable-msg=C0301,C0324'; \
895           echo '# because this is autogenerated, we do not want'; \
896           echo '# style warnings' ; \
897           echo ''; \
898           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
899           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
900           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
901           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
902           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
903           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
904           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
905           echo "SYSCONFDIR = '$(sysconfdir)'"; \
906           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
907           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
908           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
909           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
910           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
911           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
912           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
913           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
914           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
915           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
916           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
917           echo "KVM_PATH = '$(KVM_PATH)'"; \
918           echo "IP_PATH = '$(IP_PATH)'"; \
919           echo "SOCAT_PATH = '$(SOCAT)'"; \
920           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
921           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
922           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
923           echo "TOOLSDIR = '$(toolsdir)'"; \
924           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
925           echo "PKGLIBDIR = '$(pkglibdir)'"; \
926           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
927           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
928           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
929           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
930           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
931           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
932           echo "RAPI_USER = '$(RAPI_USER)'"; \
933           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
934           echo "CONFD_USER = '$(CONFD_USER)'"; \
935           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
936           echo "NODED_USER = '$(NODED_USER)'"; \
937           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
938           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
939           if [ "$(HTOOLS)" ]; then \
940             echo "HTOOLS = True"; \
941           else \
942             echo "HTOOLS = False"; \
943           fi; \
944         } > $@
945
946 lib/_vcsversion.py: Makefile vcs-version | lib/.dir
947         set -e; \
948         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
949         { echo '# This file is automatically generated, do not edit!'; \
950           echo '#'; \
951           echo ''; \
952           echo '"""Build-time VCS version number for Ganeti.'; \
953           echo '';\
954           echo 'This file is autogenerated by the build process.'; \
955           echo 'For any changes you need to re-run ./configure (and'; \
956           echo 'not edit by hand).'; \
957           echo ''; \
958           echo '"""'; \
959           echo ''; \
960           echo '# pylint: disable-msg=C0301,C0324'; \
961           echo '# because this is autogenerated, we do not want'; \
962           echo '# style warnings' ; \
963           echo ''; \
964           echo "VCS_VERSION = '$$VCSVER'"; \
965         } > $@
966
967 $(REPLACE_VARS_SED): Makefile
968         set -e; \
969         { echo 's#@PREFIX@#$(prefix)#g'; \
970           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
971           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
972           echo 's#@BINDIR@#$(bindir)#g'; \
973           echo 's#@SBINDIR@#$(sbindir)#g'; \
974           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
975           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
976           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
977           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
978           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
979           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
980           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
981           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
982           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
983           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
984           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
985           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
986           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
987           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
988           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
989           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
990           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
991           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
992         } > $@
993
994 # Using deferred evaluation
995 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
996 daemons/ganeti-watcher: MODULE = ganeti.watcher
997 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
998 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
999
1000 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1001         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1002         set -e; \
1003         { echo '#!/usr/bin/python'; \
1004           echo '# This file is automatically generated, do not edit!'; \
1005           echo "# Edit $(MODULE) instead."; \
1006           echo; \
1007           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1008           echo; \
1009           echo '# pylint: disable-msg=C0103'; \
1010           echo '# C0103: Invalid name'; \
1011           echo; \
1012           echo 'import sys'; \
1013           echo 'import $(MODULE) as main'; \
1014           echo; \
1015           echo '# Temporarily alias commands until bash completion'; \
1016           echo '# generator is changed'; \
1017           echo 'if hasattr(main, "commands"):'; \
1018           echo '  commands = main.commands # pylint: disable-msg=E1101'; \
1019           echo 'if hasattr(main, "aliases"):'; \
1020           echo '  aliases = main.aliases # pylint: disable-msg=E1101'; \
1021           echo; \
1022           echo 'if __name__ == "__main__":'; \
1023           echo '  sys.exit(main.Main())'; \
1024         } > $@
1025         chmod u+x $@
1026
1027 # We need to create symlinks because "make distcheck" will not install Python
1028 # files when building.
1029 stamp-srclinks: Makefile | $(all_dirfiles)
1030         set -e; \
1031         for i in $(srclink_files); do \
1032                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1033                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1034                 fi; \
1035         done
1036         touch $@
1037
1038 .PHONY: ganeti
1039 ganeti:
1040         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1041
1042 .PHONY: check-dirs
1043 check-dirs: $(BUILT_SOURCES)
1044         @set -e; \
1045         find . -type d \( \( -name . \) -o \( \
1046                 -name .git -o \
1047                 -name autom4te.cache \
1048                 \) -prune -o -print \) | { \
1049                 error=; \
1050                 while read dir; do \
1051                         case "$$dir" in \
1052                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1053                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1054                         esac; \
1055                 done; \
1056                 for dir in $(DIRS); do \
1057                         if ! test -d "$$dir"; then \
1058                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
1059                                 error=1; \
1060                         fi \
1061                 done; \
1062                 if test -n "$$error"; then exit 1; else exit 0; fi; \
1063         }
1064
1065 check-local: check-dirs
1066         $(CHECK_PYTHON_CODE) $(check_python_code)
1067         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1068         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1069         expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1070         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1071                 echo "Incorrect version in README, expected $$expver"; \
1072                 exit 1; \
1073         fi; \
1074         for file in doc/iallocator.rst doc/hooks.rst; do \
1075                 if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1076                         "Documents Ganeti version $$expver"; then \
1077                         echo "Incorrect version in $$file, expected $$expver"; \
1078                         exit 1; \
1079                 fi; \
1080         done
1081
1082 .PHONY: hs-check
1083 hs-check: htools/test
1084         @rm -f test.tix
1085         ./htools/test
1086
1087 # E111: indentation is not a multiple of four
1088 # E261: at least two spaces before inline comment
1089 # E501: line too long (80 characters)
1090 PEP8_IGNORE = E111,E261,E501
1091
1092 # For excluding pep8 expects filenames only, not whole paths
1093 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1094
1095 .PHONY: lint
1096 lint: $(BUILT_SOURCES)
1097         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1098         if test -z "$(PEP8)"; then \
1099                 echo '"pep8" not found during configure' >&2; \
1100         else \
1101                 $(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1102                         $(pep8_python_code); \
1103         fi
1104         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1105         cd $(top_srcdir)/qa && \
1106           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1107           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1108
1109 .PHONY: hlint
1110 hlint: $(HS_BUILT_SRCS)
1111         if tty -s; then C="-c"; else C=""; fi; \
1112         hlint --report=doc/hs-lint.html $$C htools
1113
1114 # a dist hook rule for updating the vcs-version file; this is
1115 # hardcoded due to where it needs to build the file...
1116 dist-hook:
1117         $(MAKE) regen-vcs-version && \
1118         rm -f $(top_distdir)/vcs-version && \
1119         cp -p $(srcdir)/vcs-version $(top_distdir)
1120
1121 # a distcheck hook rule for catching revision control directories
1122 distcheck-hook:
1123         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1124                 echo "Found revision control files in final archive." 1>&2; \
1125                 exit 1; \
1126         fi
1127         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1128                 echo "Found Python byte code in final archive." 1>&2; \
1129                 exit 1; \
1130         fi
1131         if find $(top_distdir) -name '*~' | grep .; then \
1132                 echo "Found backup files in final archive." 1>&2; \
1133                 exit 1; \
1134         fi
1135 # Empty files or directories should not be distributed. They can cause
1136 # unnecessary warnings for packagers. Directories used by automake during
1137 # distcheck must be excluded.
1138         if find $(top_distdir) -empty -and -not \( \
1139                         -path $(top_distdir)/_build -or \
1140                         -path $(top_distdir)/_inst \) | grep .; then \
1141                 echo "Found empty files or directories in final archive." 1>&2; \
1142                 exit 1; \
1143         fi
1144         if test -n "$(BUILD_RELEASE)" && \
1145            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1146                 echo "Found unreleased version in NEWS." >&2; \
1147                 exit 1; \
1148         fi
1149
1150 # When building a release, stricter checks should be used
1151 distcheck-release dist-release: export BUILD_RELEASE = 1
1152 distcheck-release: distcheck
1153
1154 dist-release: dist
1155         set -e; \
1156         for i in $(DIST_ARCHIVES); do \
1157                 echo -n "Checking $$i ... "; \
1158                 autotools/check-tar < $$i; \
1159                 echo OK; \
1160         done
1161
1162 install-exec-local:
1163         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1164           "$(DESTDIR)${localstatedir}/log/ganeti" \
1165           "$(DESTDIR)${localstatedir}/run/ganeti"
1166
1167 # To avoid conflicts between directory names and other targets, a file inside
1168 # the directory is used to ensure its existence.
1169 %.dir:
1170         @mkdir_p@ $* && touch $@
1171
1172 .PHONY: apidoc
1173 if WANT_HTOOLSAPIDOC
1174 apidoc: py-apidoc hs-apidoc
1175 else
1176 apidoc: py-apidoc
1177 endif
1178
1179 .PHONY: py-apidoc
1180 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1181         $(RUN_IN_TEMPDIR) epydoc -v \
1182                 --conf $(CURDIR)/epydoc.conf \
1183                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1184
1185 .PHONY: hs-apidoc
1186 hs-apidoc: $(HS_BUILT_SRCS)
1187         @test -n "$(HSCOLOUR)" || \
1188             { echo 'HsColour' not found during configure; exit 1; }
1189         @test -n "$(HADDOCK)" || \
1190             { echo 'haddock' not found during configure; exit 1; }
1191         rm -rf $(APIDOC_HS_DIR)/*
1192         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1193         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1194         $(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1195         set -e ; \
1196         cd htools; \
1197         if [ "$(HTOOLS_NOCURL)" ]; \
1198         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1199         else OPTGHC=""; \
1200         fi; \
1201         if [ "$(HTOOLS_PARALLEL3)" ]; \
1202         then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1203         fi; \
1204         RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1205         for file in $$RELSRCS; do \
1206                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1207                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1208         done ; \
1209         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1210                 -t ganeti-htools -p haddock-prologue \
1211                 --source-module="%{MODULE/.//}.html" \
1212                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1213                 $$OPTGHC \
1214                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1215
1216 .PHONY: TAGS
1217 TAGS: $(BUILT_SOURCES)
1218         rm -f TAGS
1219         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1220           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1221           -path './qa/*.py' | \
1222           etags -l python -
1223
1224 .PHONY: coverage
1225 if WANT_HTOOLS
1226 coverage: py-coverage hs-coverage
1227 else
1228 coverage: py-coverage
1229 endif
1230
1231 .PHONY: py-coverage
1232 py-coverage: $(BUILT_SOURCES) $(python_tests)
1233         set -e; \
1234         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1235         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1236         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1237         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1238         $(python_tests)
1239
1240 .PHONY: hs-coverage
1241 hs-coverage: $(haskell_tests)
1242         cd htools && rm -f *.tix *.mix && ./test
1243         @mkdir_p@ $(COVERAGE_HS_DIR)
1244         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1245         hpc report htools/test $(HPCEXCL)
1246         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1247
1248 # Special "kind-of-QA" target for htools, needs special setup (all
1249 # tools compiled with -fhpc)
1250 .PHONY: live-test
1251 live-test: all
1252         set -e ; \
1253         cd htools; \
1254         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1255         rm -f *.tix *.mix; \
1256         ./live-test.sh; \
1257         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1258           --output=live-test.tix ; \
1259         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1260         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1261                 --srcdir=.. $(HPCEXCL) ; \
1262         hpc report --srcdir=.. live-test $(HPCEXCL)
1263
1264 commit-check: distcheck lint apidoc
1265
1266 -include ./Makefile.local
1267
1268 # vim: set noet :